
; ========================================================
;			
;    -- Graph.inc --	
;			Jay Sullivan
; ========================================================
  
;#################################################
;#                Macro
;#################################################

$String MACRO sTEXT
	LOCAL szText
	.data
	 szText db sTEXT, 0
	.code
	EXITM <Offset szText>
ENDM
$Const MACRO Num
	result textequ @CatStr(<c_>,<%Num>)
	%IFNDEF result
	  .const 
	    result dd Num
	  .code
 	ENDIF
	EXITM <result>
ENDM

  LOWORD MACRO x
  	exitm <word ptr [x]>
  ENDM
  HIWORD MACRO x
  	exitm <word ptr [x+2]>
  ENDM
  
  
	$immediate_float MACRO Num, NumType
	 	IFIDN @SubStr(<Num>,1,1),<->
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<_c_>,NumType,<_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 		sgnlocation equ @InStr(1,%formatted,<->)
	 		formatted textequ @CatStr(<_>,@SubStr(%formatted,1,sgnlocation-1),@SubStr(%formatted,sgnlocation+1))   
	 	ELSE
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_>,NumType,<_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 	ENDIF
		%IFNDEF ASdF
		  .const 
		    formatted REAL4 Num
		  .code
	 	ENDIF
		%echo formatted
		EXITM <formatted>
	ENDM

	$hub_float MACRO num,numType
		DECPT TEXTEQU %@InStr(1, num, <.>)
		
		
		IF (OPATTR (num)) AND 00010000y  	; Register
			echo Register
			exitm <num>
		ELSEIF (OPATTR (num)) AND 00000100y ; Immediate
			DUMMYSTR TEXTEQU %num
			echo Immediate = DUMMYSTR
			exitm <$immediate_float(%@CatStr(DUMMYSTR,<.0>),numType)>
		ELSEIF (OPATTR (num)) AND 00000010y ; Memory reference
			echo Memory reference
			exitm <REAL4 ptr num>
		ELSEIF DECPT NE 0 					; Float
			echo Float = num
			exitm <$immediate_float(num,numType)>
		ELSE								; Unknown
			OPVAL TEXTEQU %OPATTR (num)
			.err <This is unknown: num -- OPATTR = OPVAL -- Not float>
		ENDIF
	ENDM
	$float MACRO NUM
		exitm <$hub_float(NUM,REAL4)>
	ENDM
	$double MACRO NUM
		exitm <$hub_float(NUM,REAL8)>
	ENDM
	$ldouble MACRO NUM
		exitm <$hub_float(NUM,REAL10)>
	ENDM
	
	
;#################################################
;#                Include
;#################################################
	include windows.inc
	include user32.inc
	include kernel32.inc
	include gdi32.inc
	includeLib user32.lib
	includeLib kernel32.lib
	includeLib gdi32.lib
	
	

;#################################################
;#                .DATA
;#################################################
	.DATA
	ClassName		db "MainWinClass",0
	szAppName		db "Jaygraph",0
	.DATA?
	hInstance		HINSTANCE ?
	CommandLine		LPSTR ?
